Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.ComponentModel

Namespace System.Windows.Forms

   <Obsolete("use SizerPanel")> _
   Public Class SizeablePanel : Inherits CaptionedPanel

      Public _Sizer As New Sizer(Me) 'Habich die komplizierten Berechnungen hineinverlegt

#Region "Initiation"
      Public Sub New()
         MyBase.new()
         MyBase.DockPadding.All = _DefaultCaptionHeight
      End Sub
#End Region 'Initiation

#Region "PublicMembers"

      <Description("Gibt an, ob whrend des Sizens neu gezeichnet wird, oder erst zum Abschlu")> _
      <DefaultValue(True)> _
      <Category("Verhalten")> _
      Public Property SizeRedraw() As Boolean
         Get
            Return _Sizer.SizeRedraw
         End Get
         Set(ByVal NewValue As Boolean)
            _Sizer.SizeRedraw = NewValue
         End Set
      End Property


      Public Overrides Property Dock() As System.Windows.Forms.DockStyle
         'Das Docking bestimmt gleichzeitig, welcher Rand ziehbar ist, der dem Docking abgewandte
         '! nmlich
         Get
            Return MyBase.Dock
         End Get
         Set(ByVal Value As System.Windows.Forms.DockStyle)
            If Value = MyBase.Dock Then Return
            Dim SplitWidth As Integer = Me.SplitterWidth
            If SplitWidth = 0 Then SplitWidth = _DefaultCaptionHeight
            MyBase.Dock = Value
            Me.SplitterWidth = SplitWidth
         End Set
      End Property


      <Browsable(True)> _
      <Category("Darstellung")> _
      Public Property SplitterWidth() As Integer
         'Die Breite des Zieh-Randes besteht einfach aus einem einseitigen Padding.
         Get
            Select Case MyBase.Dock
               Case DockStyle.Top
                  Return MyBase.Padding.Bottom
               Case DockStyle.Left
                  Return MyBase.Padding.Right
               Case DockStyle.Bottom
                  Return MyBase.Padding.Top
               Case DockStyle.Right
                  Return MyBase.Padding.Left
               Case DockStyle.Fill, DockStyle.None
                  Return MyBase.Padding.Bottom
            End Select
         End Get
         Set(ByVal Value As Integer)
            Select Case MyBase.Dock
               Case DockStyle.Top
                  MyBase.Padding = New Padding(0, 0, 0, Value)
                  _CaptionStringFormat.LineAlignment = StringAlignment.Far
               Case DockStyle.Left
                  MyBase.Padding = New Padding(0, 0, Value, 0)
                  _CaptionStringFormat.LineAlignment = StringAlignment.Center
               Case DockStyle.Bottom
                  MyBase.Padding = New Padding(0, Value, 0, 0)
                  _CaptionStringFormat.LineAlignment = StringAlignment.Near
               Case DockStyle.Right
                  MyBase.Padding = New Padding(Value, 0, 0, 0)
                  _CaptionStringFormat.LineAlignment = StringAlignment.Center
               Case DockStyle.None
                  MyBase.Padding = New Padding(Value)
                  _CaptionStringFormat.LineAlignment = StringAlignment.Near
               Case DockStyle.Fill
                  MyBase.Padding = New Padding(0)
                  _CaptionStringFormat.LineAlignment = StringAlignment.Near
            End Select
         End Set
      End Property

      <Browsable(True)> _
      <Category("Darstellung")> _
      Public Property CaptionAlign() As System.Drawing.StringAlignment
         Get
            Return _CaptionStringFormat.Alignment
         End Get
         Set(ByVal value As System.Drawing.StringAlignment)
            Me.CaptionStringFormat.Alignment = value
         End Set
      End Property

#Region "PublicMembers.PropertiesVormDesignerVerbergen"
      'Ich finde, das erhht die Usability erheblich, wenn's Eigenschaftenfenster nicht zu voll ist

      <Browsable(False)> _
      Public Shadows ReadOnly Property CaptionStringFormat() As StringFormat
         Get
            If MyDesignMode.True Then Invalidate(False)
            Return _CaptionStringFormat
         End Get
      End Property

      <Browsable(False)> _
      Public Shadows Property Padding() As Padding
         Get
            Return MyBase.Padding
         End Get
         Set(ByVal NewValue As Padding)
            MyBase.Padding = NewValue
         End Set
      End Property

#End Region 'PublicMembers.PropertiesVormDesignerVerbergen
#End Region 'PublicMembers

#Region "ProcessingEvents"

      Protected Overrides Sub OnMouseEnter(ByVal e As System.EventArgs)
         MyBase.OnMouseEnter(e)
         Select Case MyBase.Dock
            Case DockStyle.Bottom, DockStyle.Top
               MyBase.Cursor = Cursors.SizeNS

            Case DockStyle.None, DockStyle.Fill
               MyBase.Cursor = Cursors.SizeAll

            Case DockStyle.Left, DockStyle.Right
               MyBase.Cursor = Cursors.SizeWE

         End Select
      End Sub
      Protected Overrides Sub OnMouseLeave(ByVal e As System.EventArgs)
         MyBase.OnMouseLeave(e)
         MyBase.Cursor = Cursors.Default
      End Sub

      Protected Overrides Sub OnMouseDown(ByVal e As System.Windows.Forms.MouseEventArgs)
         If e.Button = Windows.Forms.MouseButtons.Left Then
            _Sizer.InitDrag(e.Location)
         End If
         MyBase.OnMouseDown(e)
      End Sub

      Protected Overrides Sub OnMouseMove(ByVal e As System.Windows.Forms.MouseEventArgs)
         If e.Button = Windows.Forms.MouseButtons.Left Then
            _Sizer.MoveSplitter(e.Location)
         End If
         MyBase.OnMouseMove(e)
      End Sub

      Protected Overrides Sub OnMouseUp(ByVal e As System.Windows.Forms.MouseEventArgs)
         If e.Button = Windows.Forms.MouseButtons.Left Then
            _Sizer.EndSize()
         End If
         MyBase.OnMouseUp(e)
      End Sub

#End Region 'ProcessingEvents

   End Class

End Namespace
