﻿
Public Class ComShellInterfaces

   <Runtime.InteropServices.Guid("00020400-0000-0000-c000-000000000046")> _
   <Runtime.InteropServices.InterfaceType(Runtime.InteropServices.ComInterfaceType.InterfaceIsIUnknown)> _
   Public Interface IDispatch
      <Runtime.InteropServices.PreserveSig()> _
      Function GetTypeInfoCount() As Integer
      Function GetTypeInfo( _
          <Runtime.InteropServices.MarshalAs(Runtime.InteropServices.UnmanagedType.U4)> ByVal iTInfo As Integer, _
          <Runtime.InteropServices.MarshalAs(Runtime.InteropServices.UnmanagedType.U4)> ByVal lcid As Integer _
          ) As Runtime.InteropServices.ComTypes.ITypeInfo
      <Runtime.InteropServices.PreserveSig()> _
      Function GetIDsOfNames(ByRef riid As Guid, ByVal rgsNames As String(), _
          <Runtime.InteropServices.MarshalAs(Runtime.InteropServices.UnmanagedType.U4)> ByVal cNames As Integer, _
          <Runtime.InteropServices.MarshalAs(Runtime.InteropServices.UnmanagedType.U4)> ByVal lcid As Integer, _
          ByVal rgDispId As Integer()) As Integer
      <Runtime.InteropServices.PreserveSig()> _
      Function Invoke(ByVal dispIdMember As Integer, ByRef riid As Guid, _
          <Runtime.InteropServices.MarshalAs(Runtime.InteropServices.UnmanagedType.U4)> ByVal lcid As Integer, _
          <Runtime.InteropServices.MarshalAs(Runtime.InteropServices.UnmanagedType.U4)> ByVal dwFlags As Integer, _
          ByRef pDispParams As Runtime.InteropServices.ComTypes.DISPPARAMS, _
          <Runtime.InteropServices.Out()> ByVal pVarResult As Object(), _
          ByRef pExcepInfo As Runtime.InteropServices.ComTypes.EXCEPINFO, _
          <Runtime.InteropServices.Out()> ByVal pArgErr As IntPtr()) As Integer
   End Interface

   <Runtime.InteropServices.ComImport()> _
   <Runtime.InteropServices.Guid("D8F015C0-C278-11CE-A49E-444553540000")> _
   <Runtime.InteropServices.TypeLibType(Runtime.InteropServices.TypeLibTypeFlags.FOleAutomation)> _
   <Runtime.InteropServices.InterfaceType(Runtime.InteropServices.ComInterfaceType.InterfaceIsDual)> _
   Public Interface IShellDispatch
      ReadOnly Property Application() As IDispatch
      ReadOnly Property Parent() As IDispatch
      Function [Namespace](ByVal vDir As Object) As Folder
      Function BrowseForFolder(ByVal hWnd As Integer, ByVal Title As String, ByVal Otions As Integer, ByVal RootFolder As Object) As Folder
      Function Windows() As IDispatch 'IDispatch
      Sub Open(ByVal vDir As Object)
      Sub Explore(ByVal vDir As Object)
      Sub MinimizeAll()
      Sub UndoMinimizeALL()
      Sub FileRun()
      Sub CascadeWindows()
      Sub TileVertically()
      Sub TileHorizontally()
      Sub ShutdownWindows()
      Sub Suspend()
      Sub EjectPC()
      Sub SetTime()
      Sub TrayProperties()
      Sub Help()
      Sub FindFiles()
      Sub FindComputer()
      Sub RefreshMenu()
      Sub ControlPanelItem(ByVal bstrDir As String)
   End Interface

   <Runtime.InteropServices.ComImport()> _
   <Runtime.InteropServices.Guid("BBCBDE60-C3FF-11CE-8350-444553540000")> _
   <Runtime.InteropServices.TypeLibType(Runtime.InteropServices.TypeLibTypeFlags.FOleAutomation)> _
   <Runtime.InteropServices.InterfaceType(Runtime.InteropServices.ComInterfaceType.InterfaceIsDual)> _
   Public Interface Folder
      ReadOnly Property Title() As String
      ReadOnly Property Application() As IDispatch
      ReadOnly Property Parent() As IDispatch
      ReadOnly Property ParentFolder() As Folder ' Shell32.Folder

      Function Items() As FolderItems ' Shell32.FolderItems
      Function ParseName(ByVal bName As String) As FolderItem ' Shell32.FolderItem
      Sub NewFolder(ByVal bName As String, Optional ByVal vOptions As Object = Nothing)
      Sub MoveHere(ByVal vItem As Object, Optional ByVal vOptions As Object = Nothing)
      Sub CopyHere(ByVal vItem As Object, Optional ByVal vOptions As Object = Nothing)
      Function GetDetailsOf(ByVal vItem As Object, ByVal iColumn As Integer) As String

   End Interface

   <Runtime.InteropServices.Guid("744129E0-CBE5-11CE-8350-444553540000")> _
   <Runtime.InteropServices.ComImport()> _
   <Runtime.InteropServices.TypeLibType(Runtime.InteropServices.TypeLibTypeFlags.FOleAutomation)> _
   <Runtime.InteropServices.InterfaceType(Runtime.InteropServices.ComInterfaceType.InterfaceIsDual)> _
   Public Interface FolderItems
      'Inherits IEnumerable
      ReadOnly Property Count() As Integer
      ReadOnly Property Application() As IDispatch
      ReadOnly Property Parent() As IDispatch
      Function Item(ByVal index As Object) As FolderItem

      <Runtime.InteropServices.DispId(-4)> _
      <Runtime.InteropServices.TypeLibFunc(Runtime.InteropServices.TypeLibFuncFlags.FRestricted Or Runtime.InteropServices.TypeLibFuncFlags.FHidden)> _
      Function _NewEnum() As Runtime.InteropServices.ComTypes.IEnumVARIANT

   End Interface

   <Runtime.InteropServices.ComImport()> _
   <Runtime.InteropServices.TypeLibType(Runtime.InteropServices.TypeLibTypeFlags.FOleAutomation)> _
   <Runtime.InteropServices.InterfaceType(Runtime.InteropServices.ComInterfaceType.InterfaceIsDual)> _
   <Runtime.InteropServices.Guid("FAC32C80-CBE4-11CE-8350-444553540000")> _
   Public Interface FolderItem
      ReadOnly Property Application() As IDispatch
      ReadOnly Property Parent() As IDispatch
      Property Name() As String
      ReadOnly Property Path() As String
      ReadOnly Property GetLink() As IDispatch
      ReadOnly Property GetFolder() As IDispatch
      ReadOnly Property IsLink() As Boolean
      ReadOnly Property IsFolder() As Boolean
      ReadOnly Property IsFileSystem() As Boolean
      ReadOnly Property IsBrowsable() As Boolean
      Property ModifyDate() As Date
      ReadOnly Property Size() As Integer
      ReadOnly Property Type() As String
      Function Verbs() As FolderItemVerbs
      Sub InvokeVerb(ByVal vVerb As Object)
   End Interface

   <Runtime.InteropServices.ComImport()> _
   <Runtime.InteropServices.TypeLibType(Runtime.InteropServices.TypeLibTypeFlags.FOleAutomation)> _
   <Runtime.InteropServices.InterfaceType(Runtime.InteropServices.ComInterfaceType.InterfaceIsDual)> _
   <Runtime.InteropServices.Guid("1F8352C0-50B0-11CF-960C-0080C7F4EE85")> _
   Public Interface FolderItemVerbs
      'Inherits IEnumerable
      ReadOnly Property Count() As Integer
      ReadOnly Property Application() As IDispatch
      ReadOnly Property Parent() As IDispatch
      Function Item(ByVal index As Object) As FolderItemVerb

      <Runtime.InteropServices.DispId(-4)> _
      <Runtime.InteropServices.TypeLibFunc(Runtime.InteropServices.TypeLibFuncFlags.FRestricted Or Runtime.InteropServices.TypeLibFuncFlags.FHidden)> _
      Function _NewEnum() As Runtime.InteropServices.ComTypes.IEnumVARIANT
   End Interface

   <Runtime.InteropServices.ComImport()> _
   <Runtime.InteropServices.TypeLibType(Runtime.InteropServices.TypeLibTypeFlags.FOleAutomation)> _
   <Runtime.InteropServices.InterfaceType(Runtime.InteropServices.ComInterfaceType.InterfaceIsDual)> _
   <Runtime.InteropServices.Guid("08EC3E00-50B0-11CF-960C-0080C7F4EE85")> _
   Public Interface FolderItemVerb
      ReadOnly Property Application() As IDispatch
      ReadOnly Property Parent() As IDispatch
      ReadOnly Property Name() As String
      Sub DoIt()
   End Interface

End Class
